﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;

namespace DigitalSchoolApi.Models
{
    /// <summary>
    /// 描 述：学生宿舍管理
    /// </summary>
    public class Acc_DormitoryBuildEntity
    {

        #region  实体成员
        /// <summary>
        /// 编号
        /// </summary>
        public string ID { get; set; }
        /// <summary>
        /// 编号
        /// </summary>
        public string DNo { get; set; }

        /// <summary>
        /// 名称
        /// </summary>
        public string Name { get; set; }
        /// <summary>
        /// 宿舍楼
        /// </summary>
        public string ApartmentId { get; set; }
        /// <summary>
        /// 单元
        /// </summary>
        public string UnitId { get; set; }
        /// <summary>
        /// 楼层
        /// </summary>
        public string FloorId { get; set; }
        /// <summary>
        /// 负责人
        /// </summary>
        public string Functionary { get; set; }
        /// <summary>
        /// 舍长
        /// </summary>
        public string Leader { get; set; }
        /// <summary>
        /// 类型（宿舍楼，单元，楼层，房间）
        /// </summary>
        public string BuildType { get; set; }
        /// <summary>
        /// 创建人
        /// </summary>
        public string CreateBy { get; set; }
        /// <summary>
        /// 创建时间
        /// </summary>
        public DateTime? CreateTime { get; set; }
        /// <summary>
        /// 更新人
        /// </summary>
        public string UpdateBy { get; set; }
        /// <summary>
        /// 更新时间
        /// </summary>
        public DateTime? UpdateTime { get; set; }
        /// <summary>
        /// 价格
        /// </summary>
        public decimal? Price { get; set; }
        /// <summary>
        /// 备注说明
        /// </summary>
        public string Remark { get; set; }
        /// <summary>
        /// 电话
        /// </summary>
        public string Phone { get; set; }
        /// <summary>
        /// 位置
        /// </summary>
        public string Address { get; set; }
        /// <summary>
        /// 校区
        /// </summary>
        public string Campus { get; set; }
        /// <summary>
        /// 系
        /// </summary>
        public string Dept { get; set; }
        /// <summary>
        /// 专业
        /// </summary>
        public string Major { get; set; }
        /// <summary>
        /// 班级
        /// </summary>
        public string Class { get; set; }
        /// <summary>
        /// 主班级
        /// </summary>
        public string MainClass { get; set; }
        /// <summary>
        /// 性别
        /// </summary>
        public string Sex { get; set; }
        /// <summary>
        /// 住宿学生编号（存值为StuNo）
        /// </summary>
        public string StudentID { get; set; }
        /// <summary>
        /// 预分学生id
        /// </summary>
        public string PlanStudentID { get; set; }
        /// <summary>
        /// 父ID
        /// </summary>
        public string ParentID { get; set; }

        /// <summary>
        /// 是否独卫
        /// </summary>
        public string HasToilet { get; set; }
        /// <summary>
        /// 星级
        /// </summary>
        public string Starred { get; set; }
        /// <summary>
        /// 预分班级no
        /// </summary>
        public string PlanClassNo { get; set; }
        /// <summary>
        /// 排序
        /// </summary>
        public int? sort { get; set; }
        /// <summary>
        /// 预分床位数量（宿舍名时有值）
        /// </summary>
        public int? PlanBedNum { get; set; }

        /// <summary>
        /// 寝室类型（几人寝）
        /// </summary>
        public int? RoomType { get; set; }
        /// <summary>
        /// 入住人数
        /// </summary>
        public int? CheckInStu { get; set; }
        /// <summary>
        /// 是否归宿
        /// </summary>
        public int? IsReturn { get; set; }
        
        #endregion

    }
}