﻿using System;

namespace DigitalSchoolApi.Models
{
    /// <summary>
    /// 描 述：固定资产
    /// </summary>
    public class Ass_FixAssetsEntity 
    {
        #region 实体成员
        /// <summary>
        /// 主键
        /// </summary>
        public string FAId { get; set; }
        /// <summary>
        /// 资产编号
        /// </summary>
        public string FACode { get; set; }
        /// <summary>
        /// 资产国标大类
        /// </summary>
        public string ATGId { get; set; }
        /// <summary>
        /// 资产分类
        /// </summary>
        public string ATId { get; set; }
        /// <summary>
        /// 资产名称
        /// </summary>
        public string FAName { get; set; }
        /// <summary>
        /// 财务入账日期
        /// </summary>
        public DateTime? FinanceEntryDate { get; set; }
        /// <summary>
        /// 价值类型
        /// </summary>
        public string ValueType { get; set; }
        /// <summary>
        /// 价值
        /// </summary>
        public decimal? Value { get; set; }
        /// <summary>
        /// 取得方式
        /// </summary>
        public string GetWay { get; set; }
        /// <summary>
        /// 取得日期
        /// </summary>
        public DateTime? GetDate { get; set; }
        /// <summary>
        /// 使用状况
        /// </summary>
        public string UseCondition { get; set; }
        /// <summary>
        /// 使用部门
        /// </summary>
        public string UseDepartment { get; set; }
        /// <summary>
        /// 管理部门
        /// </summary>
        public string ManageDepartment { get; set; }
        /// <summary>
        /// 使用人
        /// </summary>
        public string UsePeople { get; set; }
        /// <summary>
        /// 数量
        /// </summary>
        public int? Amount { get; set; }
        /// <summary>
        /// 制单人
        /// </summary>
        public string MakePeople { get; set; }
        /// <summary>
        /// 制单时间
        /// </summary>
        public DateTime? MakeDate { get; set; }
        /// <summary>
        /// 所属单位
        /// </summary>
        public string Unit { get; set; }
        /// <summary>
        /// 卡片状态
        /// </summary>
        public string CardStatus { get; set; }
        /// <summary>
        /// 折旧年限
        /// </summary>
        public int? DepreciationLife { get; set; }
        /// <summary>
        /// 累计折旧
        /// </summary>
        public decimal? AccumulatedDepreciation { get; set; }
        /// <summary>
        /// 已提折旧月数
        /// </summary>
        public int? HaveDepreciationMonths { get; set; }
        /// <summary>
        /// 月折旧额
        /// </summary>
        public decimal? MonthlyDepreciation { get; set; }
        /// <summary>
        /// 折旧方法
        /// </summary>
        public string DepreciationMothod { get; set; }
        /// <summary>
        /// 净值
        /// </summary>
        public decimal? NetValue { get; set; }
        /// <summary>
        /// 采购组织形式
        /// </summary>
        public string PurchaseOrganizationForm { get; set; }
        /// <summary>
        /// 品牌
        /// </summary>
        public string Brand { get; set; }
        /// <summary>
        /// 规格型号
        /// </summary>
        public string SpecificationModel { get; set; }
        /// <summary>
        /// 存放地点
        /// </summary>
        public string StorageId { get; set; }
        /// <summary>
        /// 销售商
        /// </summary>
        public string SupplierId { get; set; }
        /// <summary>
        /// 使用权面积/建筑面积
        /// </summary>
        public decimal? UseArea { get; set; }
        /// <summary>
        /// 财政拨款
        /// </summary>
        public decimal? FinancialAppropriation { get; set; }
        /// <summary>
        /// 非财政拨款
        /// </summary>
        public decimal? NonFinancialAppropriation { get; set; }
        /// <summary>
        /// 会计凭证号
        /// </summary>
        public string AccountDocumentNumber { get; set; }
        /// <summary>
        /// 折旧/摊销状态
        /// </summary>
        public string DepreciationStatus { get; set; }
        /// <summary>
        /// CreateUserId
        /// </summary>
        public string CreateUserId { get; set; }
        /// <summary>
        /// CreateTime
        /// </summary>
        public DateTime? CreateTime { get; set; }
        /// <summary>
        /// ModifyUserId
        /// </summary>
        public string ModifyUserId { get; set; }
        /// <summary>
        /// ModifyTime
        /// </summary>
        public DateTime? ModifyTime { get; set; }
        /// <summary>
        /// SubmitUserId
        /// </summary>
        public string SubmitUserId { get; set; }
        /// <summary>
        /// SubmitTime
        /// </summary>
        public DateTime? SubmitTime { get; set; }
        /// <summary>
        /// 状态(0草稿，1已提交，2审核通过，3审核未通过)
        /// </summary>
        public int? Status { get; set; }
        /// <summary>
        /// 流程主键
        /// </summary>
        public string ProcessId { get; set; }
        #endregion
        
    }
}

