﻿using Learun.Util;
using System;
using System.ComponentModel.DataAnnotations.Schema;

namespace Learun.Application.TwoDevelopment.ReceiveSendFeeManagement
{
    /// <summary>
    /// 版 本 Learun-ADMS V7.0.6 力软敏捷开发框架
    /// Copyright (c) 2013-2020 力软信息技术（苏州）有限公司
    /// 创 建：超级管理员
    /// 日 期：2023-08-12 22:14
    /// 描 述：FinaChargeStuOrderDetail
    /// </summary>
    public class FinaChargeStuOrderDetailEntity 
    {
        #region 实体成员
        /// <summary>
        /// Id
        /// </summary>
       
        public string Id { get; set; }
        /// <summary>
        /// FCSOId
        /// </summary>
        public string FCSOId { get; set; }
        /// <summary>
        /// ChargeItemCode
        /// </summary>
        public string ChargeItemCode { get; set; }
        /// <summary>
        /// 发票代码
        /// </summary>
        public string InvoiceTypeCode { get; set; }
        /// <summary>
        /// ChargeItemName
        /// </summary>
        public string ChargeItemName { get; set; }
        /// <summary>
        /// 应缴
        /// </summary>
        public decimal? YJAmount { get; set; }
        /// <summary>
        /// 实缴
        /// </summary>
        public decimal? SJAmount { get; set; }
        /// <summary>
        /// 待缴
        /// </summary>
        public decimal? DJAmount { get; set; }
        /// <summary>
        /// 超出余额
        /// </summary>
        public decimal? NowBlance { get; set; }
        #endregion

        #region 扩展操作
        /// <summary>
        /// 新增调用
        /// </summary>
        public void Create()
        {
            this.Id = Guid.NewGuid().ToString();
            NowBlance = 0;
        }
        /// <summary>
        /// 编辑调用
        /// </summary>
        /// <param name="keyValue"></param>
        public void Modify(string keyValue)
        {
            this.Id = keyValue;
        }
        #endregion
        #region 扩展字段
        #endregion
    }
}

