﻿using Learun.Util;
using System;
using System.ComponentModel.DataAnnotations.Schema;

namespace Learun.Application.TwoDevelopment.ReceiveSendFeeManagement
{
    /// <summary>
    /// 版 本 Learun-ADMS V7.0.6 力软敏捷开发框架
    /// Copyright (c) 2013-2020 力软信息技术（苏州）有限公司
    /// 创 建：超级管理员
    /// 日 期：2023-08-12 22:06
    /// 描 述：缴费订单管理
    /// </summary>
    public class FinaChargeStuOrderEntity 
    {
        #region 实体成员
        /// <summary>
        /// Id
        /// </summary>
        public string Id { get; set; }
        /// <summary>
        /// FSYId
        /// </summary>
        public string FSYId { get; set; }
        /// <summary>
        /// 年度
        /// </summary>
        public int? YearNo { get; set; }
        /// <summary>
        /// 学号
        /// </summary>
        public string StuNo { get; set; }
        /// <summary>
        /// 订单编号
        /// </summary>
        public string orderid { get; set; }
        /// <summary>
        /// 应交金额
        /// </summary>
        public decimal? YJAmount { get; set; }
        /// <summary>
        /// 实交金额
        /// </summary>
        public decimal? SJAmount { get; set; }
        /// <summary>
        /// 待缴金额
        /// </summary>
        public decimal? DJAmount { get; set; }
        /// <summary>
        /// 超出余额
        /// </summary>
        public decimal? NowBlance { get; set; }
        /// <summary>
        /// 缴费订单状态（0未支付，1已支付）
        /// </summary>
        public int? Status { get; set; }
        /// <summary>
        /// 下单时间
        /// </summary>
        public DateTime? PlaceOrderTime { get; set; }
        /// <summary>
        /// 付款时间
        /// </summary>
        public DateTime? PayTime { get; set; }
        /// <summary>
        /// 付款方式
        /// </summary>
        public string PayMode { get; set; }
        /// <summary>
        /// 订单来源（1二维码缴费，2人工导入）
        /// </summary>
        public int? OrderType { get; set; }
        /// <summary>
        /// 银行流水号
        /// </summary>
        public string BankOrder { get; set; }
        #endregion

        #region 扩展操作
        /// <summary>
        /// 新增调用
        /// </summary>
        public void Create()
        {
            this.Id = Guid.NewGuid().ToString();
            NowBlance = 0;
        }
        /// <summary>
        /// 编辑调用
        /// </summary>
        /// <param name="keyValue"></param>
        public void Modify(string keyValue)
        {
            this.Id = keyValue;
        }
        #endregion
        #region 扩展字段
        #endregion
    }
}

