﻿using Learun.Util;
using System;
using System.ComponentModel.DataAnnotations.Schema;

namespace Learun.Application.TwoDevelopment.ReceiveSendFeeManagement
{
    /// <summary>
    /// 版 本 Learun-ADMS V7.0.6 力软敏捷开发框架
    /// Copyright (c) 2013-2020 力软信息技术（苏州）有限公司
    /// 创 建：超级管理员
    /// 日 期：2023-08-07 16:40
    /// 描 述：FinaChargeStuYearItem
    /// </summary>
    public class FinaChargeStuYearItemEntity 
    {
        #region 实体成员
        /// <summary>
        /// FSYIId
        /// </summary>
        public string FSYIId { get; set; }
        /// <summary>
        /// FSYId
        /// </summary>
        public string FSYId { get; set; }

        public int? FSYear { get; set; }
        /// <summary>
        /// ChargeItemCode
        /// </summary>
        public string ChargeItemCode { get; set; }
        /// <summary>
        /// 收费项名称
        /// </summary>
        public string ChargeItemName { get; set; }
        /// <summary>
        /// ChargeItemType
        /// </summary>
        public int? ChargeItemType { get; set; }
        /// <summary>
        /// 优先级
        /// </summary>
        public int? priority { get; set; }
        /// <summary>
        /// 收费标准
        /// </summary>
        public decimal? Standard { get; set; }
        /// <summary>
        /// SJAmount
        /// </summary>
        public decimal? SJAmount { get; set; }

        /// <summary>
        /// 剩余待缴
        /// </summary>
        public decimal? NeedToPay { get; set; }
        /// <summary>
        /// 超出缴费余额
        /// </summary>
        public decimal? FSBlance { get; set; }
        /// <summary>
        /// 缴费标志（0未缴费，1已缴清，4部分缴纳）
        /// </summary>
        public int? PayFeeStatus { get; set; }
        /// <summary>
        /// F_DeleteMark
        /// </summary>
        public bool? F_DeleteMark { get; set; }
        /// <summary>
        /// 创建时间
        /// </summary>
        public DateTime? F_CreateDate { get; set; }
        /// <summary>
        /// 创建人主键
        /// </summary>
        public string F_CreateUserId { get; set; }
        /// <summary>
        /// 创建人名字
        /// </summary>
        public string F_CreateUserName { get; set; }
        #endregion
        
        #region 扩展字段
        [NotMapped]
        public string StuNo { get; set; }
        [NotMapped]
        public string StuName { get; set; }
        [NotMapped]
        public string MajorNo { get; set; }
        [NotMapped]
        public string ClassNo { get; set; }
        [NotMapped]
        public string DeptNo { get; set; }
        [NotMapped]
        public string InvoiceTypeCode { get; set; }
        #endregion
    }
}

