﻿using Learun.Util;
using System;
using System.ComponentModel.DataAnnotations.Schema;

namespace Learun.Application.TwoDevelopment.EducationalAdministration
{
    /// <summary>
    /// 新生缴费单
    /// </summary>
    public class StuEnrollFeeOrderEntity
    {
        #region  实体成员
        /// <summary>
        /// ID
        /// </summary>
        public string Id { get; set; }
        /// <summary>
        /// 年度
        /// </summary>
        public int? YearNo { get; set; }
        /// <summary>
        /// 学号
        /// </summary>
        public string StuNo { get; set; }
        /// <summary>
        /// orderid
        /// </summary>
        public string orderid { get; set; }
        /// <summary>
        /// 应交金额
        /// </summary>
        public decimal? YJAmount { get; set; }
        /// <summary>
        /// 实交金额
        /// </summary>
        public decimal? SJAmount { get; set; }
        /// <summary>
        /// 下单时间
        /// </summary>
        public DateTime? PlaceOrderTime { get; set; }
        /// <summary>
        /// 缴费状态
        /// </summary>
        public int? Status { get; set; }
        /// <summary>
        /// 付款时间
        /// </summary>
        public DateTime? PayTime { get; set; }

        public string PayMode { get; set; }

        #endregion
    }
    /// <summary>
    /// 票据种类编码表
    /// </summary>
    public class StuEnrollInvoiceTypeCodeEntity
    {
        public int Id { get; set; }
        public string InvoiceTypeCode { get; set; }
        public string ProjectCode { get; set; }
        public string ProjectName { get; set; }

    }
}

