﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;

namespace DigitalSchoolApi.Models
{
    public class XCStudentEntity
    {

        public string ID { get; set; }
        /// <summary>
        /// 学号
        /// </summary>
        public string STU_NO { get; set; }
        /// <summary>
        /// 姓名
        /// </summary>
        public string NAME_ { get; set; }
        /// <summary>
        /// 所属院系代码
        /// </summary>
        public string DEPT_ID { get; set; }
        /// <summary>
        /// 专业
        /// </summary>
        public string MAJOR_CODE { get; set; }
        /// <summary>
        /// 班级
        /// </summary>
        public string CLASS_ID { get; set; }
        /// <summary>
        /// 出生日期，格式：2019-06-17
        /// </summary>
        public string BIRTHDAY { get; set; }
        /// <summary>
        /// 1：男，2：女
        /// </summary>
        public string SEX_CODE { get; set; }
        /// <summary>
        /// 民族CODE
        /// </summary>
        public string NATION_CODE { get; set; }
        /// <summary>
        /// 政治面貌CODE
        /// </summary>
        public string POLITICS_CODE { get; set; }
        /// <summary>
        /// 学制
        /// </summary>
        public string LENGTH_SCHOOLING { get; set; }
        /// <summary>
        /// 培养层次CODE1：博士；2：硕士；3：本科；4：专科；9：其他（不可变更）
        /// </summary>
        public string PYCC_CODE { get; set; }
        /// <summary>
        /// 入学日期
        /// </summary>
        public string ENROLL_DATE { get; set; }
        /// <summary>
        /// 入学年级
        /// </summary>
        public int? ENROLL_GRADE { get; set; }
        /// <summary>
        /// 学生状态CODE 01：在读，02：休学，03：退学，04：停学，05：复学，06：流失，07：毕业，08：结业，09：肄业，12：保留入学资格，99：其他
        /// </summary>
        public string STU_STATE_CODE { get; set; }
        /// <summary>
        /// 学籍状态CODE1：在籍，2：不在籍，3：保留学籍
        /// </summary>
        public string STU_ROLL_CODE { get; set; }
        /// <summary>
        /// 户籍地址
        /// </summary>
        public string PLACE_DOMICILE { get; set; }
        /// <summary>
        /// 预计毕业学年
        /// </summary>
        public string GRADUATE_SCHOOLYEAR { get; set; }
        /// <summary>
        /// 预计毕业日期
        /// </summary>
        public string GRADUATE_DATE { get; set; }
        /// <summary>
        /// 预计毕业年
        /// </summary>
        public int? GRADUATE_YEAR { get; set; }
        /// <summary>
        /// 是否在校
        /// </summary>
        public int? IS_NORMAL { get; set; }

    }

    public class StuInfoBasicModel
    {
        #region  实体成员
        public string ID { get; set; }
        /// <summary>
        /// 学校编号
        /// </summary>
        public string F_SchoolId { get; set; }

        /// <summary>
        /// 学号
        /// </summary>
        public string StuNo { get; set; }

        /// <summary>
        /// 学籍号
        /// </summary>
        public string StuCode { get; set; }
        /// <summary>
        /// 通知书号
        /// </summary>
        public string NoticeNo { get; set; }
        /// <summary>
        /// GraduateYear
        /// </summary>
        public string GraduateYear { get; set; }
        /// <summary>
        /// 考生号
        /// </summary>
        public string ksh { get; set; }
        /// <summary>
        /// 系所代码
        /// </summary>
        public string DeptNo { get; set; }
        /// <summary>
        /// 专业代码
        /// </summary>
        public string MajorNo { get; set; }
        /// <summary>
        /// 专业方向号（如0，1，2，3，4，5）
        ///代表无专业方向细分
        /// </summary>
        public string MajorDetailNo { get; set; }
        /// <summary>
        /// 专业方向名
        /// </summary>
        public string MajorDetailName { get; set; }
        /// <summary>
        /// 年级
        /// </summary>
        public string Grade { get; set; }
        /// <summary>
        /// 行政班号
        /// </summary>
        public string ClassNo { get; set; }
        /// <summary>
        /// 姓名
        /// </summary>
        public string StuName { get; set; }
        public string FORMER_NAME { get; set; }
        /// <summary>
        /// 拼音全称
        /// </summary>
        public string SpellFull { get; set; }
        /// <summary>
        /// 拼音简称
        /// </summary>
        public string SpellBrief { get; set; }
        /// <summary>
        /// 性别码
        /// </summary>
        public bool? GenderNo { get; set; }
        /// <summary>
        /// 出生日期
        /// </summary>
        public DateTime? Birthday { get; set; }
        /// <summary>
        /// 政治面貌码
        /// </summary>
        public string PartyFaceNo { get; set; }
        /// <summary>
        /// 家庭出身份
        /// </summary>
        public string FamilyOriginNo { get; set; }
        /// <summary>
        /// 民族码
        /// </summary>
        public string NationalityNo { get; set; }
        /// <summary>
        /// 籍贯省代码 废除
        /// </summary>
        public string ProvinceNo { get; set; }
        /// <summary>
        /// 籍贯省代码代码
        /// </summary>
        public string F_ProvinceId { get; set; }
        /// <summary>
        /// 籍贯市代码
        /// </summary>
        public string F_CityId { get; set; }

        /// <summary>
        /// 籍贯县代码
        /// </summary>
        public string F_CountyId { get; set; }
        /// <summary>
        /// 籍贯
        /// </summary>
        public string RegionNo { get; set; }
        /// <summary>
        /// 农业户口（是否农户）
        /// </summary>
        public string ResidenceNo { get; set; }
        /// <summary>
        /// 考生类别
        /// </summary>
        public string TestStuSortNo { get; set; }
        /// <summary>
        /// 健康状况
        /// </summary>
        public string HealthStatusNo { get; set; }
        /// <summary>
        /// 第几志愿
        /// </summary>
        public string WillNo { get; set; }
        /// <summary>
        /// TestStuSubjectNo
        /// </summary>
        public string TestStuSubjectNo { get; set; }
        /// <summary>
        /// 本专科
        /// </summary>
        public string GraduateNo { get; set; }
        /// <summary>
        /// 计划形式
        /// </summary>
        public string PlanFormNo { get; set; }
        /// <summary>
        /// 三好
        /// </summary>
        public string IsThreeGood { get; set; }
        /// <summary>
        /// 优干
        /// </summary>
        public string IsExcellent { get; set; }
        /// <summary>
        /// 一般学生干部
        /// </summary>
        public string IsNormalCadre { get; set; }
        /// <summary>
        /// 省市前三
        /// </summary>
        public string IsProvinceFirstThree { get; set; }
        /// <summary>
        /// 港澳台侨
        /// </summary>
        public string OverseasChineseNo { get; set; }
        /// <summary>
        /// 录取类别
        /// </summary>
        public string MatriculateSort { get; set; }
        /// <summary>
        /// 来源地区码
        /// </summary>
        public string ComeProvinceNo { get; set; }
        /// <summary>
        /// 原单位码
        /// </summary>
        public string HighSchoolNo { get; set; }
        /// <summary>
        /// 原单位
        /// </summary>
        public string HighSchoolName { get; set; }
        /// <summary>
        /// 入学年月
        /// </summary>
        public DateTime? EntranceDate { get; set; }
        /// <summary>
        /// 宗教
        /// </summary>
        public string Religion { get; set; }
        /// <summary>
        /// 特长
        /// </summary>
        public string GoodAt { get; set; }
        /// <summary>
        /// 身份证号
        /// </summary>
        public string IdentityCardNo { get; set; }
        /// <summary>
        /// 入党时间
        /// </summary>
        public DateTime? JoinPartyDate { get; set; }
        /// <summary>
        /// 入团时间
        ///团员league
        /// </summary>
        public DateTime? JoinLeagueDate { get; set; }
        /// <summary>
        /// 校内地址
        /// </summary>
        public string InSchoolAddress { get; set; }
        /// <summary>
        /// 校内电话
        /// </summary>
        public string InSchoolTelephone { get; set; }
        /// <summary>
        /// 当前异动类别
        /// </summary>
        public string AbmormityMoveMark { get; set; }
        /// <summary>
        /// 奖励标志
        /// </summary>
        public string AwardMark { get; set; }
        /// <summary>
        /// 处分标志
        /// </summary>
        public string PunishMark { get; set; }
        /// <summary>
        /// 联系人标志
        /// </summary>
        public string LinkmanMark { get; set; }
        /// <summary>
        /// 学号异动标志
        /// </summary>
        public string StuNoChangeMark { get; set; }
        /// <summary>
        /// 毕业标志
        /// </summary>
        public string FinishSchoolMark { get; set; }
        /// <summary>
        /// 当前注册标志
        /// </summary>
        public string CurrentRegisterMark { get; set; }
        /// <summary>
        /// 毕业年月
        /// </summary>
        public DateTime? FinishSchoolDate { get; set; }
        /// <summary>
        /// 毕业证书号
        /// </summary>
        public string DiplomaNo { get; set; }
        /// <summary>
        /// 毕业证书备注
        /// </summary>
        public string DiplomaRemark { get; set; }
        /// <summary>
        /// 备注
        /// </summary>
        public string Remark { get; set; }
        /// <summary>
        /// 报到日期
        /// </summary>
        public DateTime? RegisterDate { get; set; }
        /// <summary>
        /// Photo
        /// </summary>
        public string Photo { get; set; }
        /// <summary>
        /// TeachPlanNo
        /// </summary>
        public string TeachPlanNo { get; set; }
        /// <summary>
        /// 审查标志
        /// </summary>
        public string CheckMark { get; set; }
        /// <summary>
        /// 联系电话（手机）
        /// </summary>
        public string mobile { get; set; }
        /// <summary>
        /// 电子邮件地址
        /// </summary>
        public string EMail { get; set; }
        /// <summary>
        ///QQ
        /// </summary>
        public string QQ { get; set; }
        /// <summary>
        /// 户口所在地
        /// </summary>
        public string FatherUnit { get; set; }
        /// <summary>
        /// 父亲姓名
        /// </summary>
        public string FatherName { get; set; }
        /// <summary>
        /// 父亲电话
        /// </summary>
        public string FatherPhone { get; set; }
        /// <summary>
        /// 母亲姓名
        /// </summary>
        public string MatherName { get; set; }
        /// <summary>
        /// 档案所在地
        /// </summary>
        public string MatherUnit { get; set; }
        /// <summary>
        /// 母亲电话
        /// </summary>
        public string MatherPhone { get; set; }
        /// <summary>
        /// 用户名
        /// </summary>
        public string username { get; set; }
        /// <summary>
        /// 密码
        /// </summary>
        public string password { get; set; }
        /// <summary>
        /// MailAddress收件人名址（收件人地址+ 姓名,可置默认值为家庭地址）
        /// </summary>
        public string MailAddress { get; set; }
        /// <summary>
        /// PostalCode邮政编码
        /// </summary>
        public string PostalCode { get; set; }
        /// <summary>
        /// InSchoolStatus
        /// </summary>
        public string InSchoolStatus { get; set; }
        /// <summary>
        /// TransMark
        /// </summary>
        public string TransMark { get; set; }
        /// <summary>
        /// ClassTutorNo
        /// </summary>
        public string ClassTutorNo { get; set; }
        /// <summary>
        /// 学籍卡审核
        /// </summary>
        public string ResumeCheck { get; set; }
        /// <summary>
        /// PracStatus
        /// </summary>
        public string PracStatus { get; set; }
        /// <summary>
        /// RegisterStatus
        /// </summary>
        public int? RegisterStatus { get; set; }
        /// <summary>
        /// PunishmentDate
        /// </summary>
        public DateTime? PunishmentDate { get; set; }
        /// <summary>
        /// StuId
        /// </summary>
        public string StuId { get; set; }

        /// <summary>
        /// 学制
        /// </summary>
        public string EduSystem { get; set; }

        /// <summary>
        /// 学习形式
        /// </summary>
        public string StudyModality { get; set; }
        /// <summary>
        /// 学籍异动状态
        /// </summary>
        /// <returns></returns>
        public int? ChangeStatus { get; set; }
        /// <summary>
        /// SyncFlag
        /// </summary>
        public bool? SyncFlag { get; set; }

        /// <summary>
        /// 余额
        /// </summary>
        public string Balance { get; set; }

        /// <summary>
        /// 身体健康状况
        /// </summary>
        public string HealthStatus { get; set; }

        /// <summary>
        /// 身份证件类型
        /// </summary>
        public string IdCardType { get; set; }
        /// <summary>
        /// 入学方式
        /// </summary>
        public string EntranceWay { get; set; }
        /// <summary>
        /// 就读方式
        /// </summary>
        public string StudyingWay { get; set; }
        /// <summary>
        /// 国籍/地区
        /// </summary>
        public string CountryNo { get; set; }
        /// <summary>
        /// 婚姻状况
        /// </summary>
        public string MarriageStatus { get; set; }
        /// <summary>
        /// 乘火车区间
        /// </summary>
        public string TrainInterval { get; set; }
        /// <summary>
        /// 是否随迁子女
        /// </summary>
        public string IsTrailChildren { get; set; }
        /// <summary>
        /// 生源地行政区划码
        /// </summary>
        public string StuPlaceCode { get; set; }
        /// <summary>
        /// 出生地行政区划码
        /// </summary>
        public string BirthPlaceCode { get; set; }
        /// <summary>
        /// 籍贯地行政区划码
        /// </summary>
        public string NativePlaceCode { get; set; }
        /// <summary>
        /// 户口所在地行政区划码
        /// </summary>
        public string ResidencePlaceCode { get; set; }
        /// <summary>
        /// 所属派出所
        /// </summary>
        public string BelongPolice { get; set; }
        /// <summary>
        /// 学生居住地类型
        /// </summary>
        public string StuLivePlaceType { get; set; }
        /// <summary>
        /// 学生来源
        /// </summary>
        public string StuOrigin { get; set; }
        /// <summary>
        /// 招生对象
        /// </summary>
        public string RecruitObject { get; set; }
        /// <summary>
        /// 贫困户否建档立卡贫困户
        /// </summary>
        public string PoorIsRecord { get; set; }
        /// <summary>
        /// 招生方式
        /// </summary>
        public string RecruitWay { get; set; }
        /// <summary>
        /// 联招合作类型
        /// </summary>
        public string RecruitCooperateType { get; set; }
        /// <summary>
        /// 准考证号
        /// </summary>
        public string AdmissionNo { get; set; }
        /// <summary>
        /// 考试总分
        /// </summary>
        public decimal? ExamScore { get; set; }
        /// <summary>
        /// 联招合作办学形式
        /// </summary>
        public string RecruitCooperateForm { get; set; }
        /// <summary>
        /// 联招合作学校代码
        /// </summary>
        public string RecruitCooperateSchoolNo { get; set; }
        /// <summary>
        /// 校外教学点
        /// </summary>
        public string SchoolOutsidePlace { get; set; }
        /// <summary>
        /// 分段培养方式
        /// </summary>
        public string PieceCultivateWay { get; set; }
        /// <summary>
        /// 英文姓名
        /// </summary>
        public string EnglishName { get; set; }
        /// <summary>
        /// 成员1关系
        /// </summary>
        public string OneMembership { get; set; }
        /// <summary>
        /// 成员1是否监护人
        /// </summary>
        public string OneIsGuardian { get; set; }
        /// <summary>
        /// 成员1出生年月
        /// </summary>
        public string OneBirthday { get; set; }
        /// <summary>
        /// 成员1身份证件类型
        /// </summary>
        public string OneIdCardType { get; set; }
        /// <summary>
        /// 成员1身份证件号
        /// </summary>
        public string OneIdCardNo { get; set; }
        /// <summary>
        /// 成员1民族
        /// </summary>
        public string OneNationalityNo { get; set; }
        /// <summary>
        /// 成员1政治面貌
        /// </summary>
        public string OnePartyFaceNo { get; set; }
        /// <summary>
        /// 成员1健康状况
        /// </summary>
        public string OneHealthStatus { get; set; }
        /// <summary>
        /// 成员1工作或学习单位
        /// </summary>
        public string OneJob { get; set; }
        /// <summary>
        /// 成员1职务
        /// </summary>
        public string OnePosition { get; set; }
        /// <summary>
        /// 成员2关系
        /// </summary>
        public string TwoMembership { get; set; }
        /// <summary>
        /// 成员2是否监护人
        /// </summary>
        public string TwoIsGuardian { get; set; }
        /// <summary>
        /// 成员2出生年月
        /// </summary>
        public string TwoBirthday { get; set; }
        /// <summary>
        /// 成员2身份证件类型
        /// </summary>
        public string TwoIdCardType { get; set; }
        /// <summary>
        /// 成员2身份证件号
        /// </summary>
        public string TwoIdCardNo { get; set; }
        /// <summary>
        /// 成员2民族
        /// </summary>
        public string TwoNationalityNo { get; set; }
        /// <summary>
        /// 成员2政治面貌
        /// </summary>
        public string TwoPartyFaceNo { get; set; }
        /// <summary>
        /// 成员2健康状况
        /// </summary>
        public string TwoHealthStatus { get; set; }
        /// <summary>
        /// 成员2工作或学习单位
        /// </summary>
        public string TwoJob { get; set; }
        /// <summary>
        /// 成员2职务
        /// </summary>
        public string TwoPosition { get; set; }
        /// <summary> 
        /// 开户银行 
        /// </summary> 
        public string DepositBank { get; set; }
        /// <summary> 
        /// 银行卡账号 
        /// </summary> 
        public string BankCard { get; set; }
        /// <summary> 
        /// 开户银行位置 
        /// </summary> 
        public string BankLocation { get; set; }
        public string PYCC_CODE { get; set; }

        #endregion

    }

    public class MiddleDicEntity
    {
        public string Id { get; set; }
        public string Mcode { get; set; }
        public string MName { get; set; }
        public string MTName { get; set; }
        public string Code { get; set; }
        public string Name { get; set; }
        public string TName { get; set; }
    }
    public class CdMajorModel
    {
        public string ID { get; set; }
        public string MajorNo { get; set; }
        public string MajorName { get; set; }
        public string F_ORDER { get; set; }
        public string ZYFL_CODE { get; set; }
        public bool? CheckMark { get; set; }
        public string DeptNo { get; set; }
        public string F_SchoolId { get; set; }
    }
    /// <summary>
    /// 专业
    /// </summary>
    public class V_ZYXX
    {
        public string ID { get; set; }
        /// <summary>
        /// 专业代码
        /// </summary>
        public string CODE_ { get; set; }
        /// <summary>
        /// 名称
        /// </summary>
        public string NAME_ { get; set; }
        /// <summary>
        /// 院系ID
        /// </summary>
        public string PID { get; set; }
        /// <summary>
        /// 排序号
        /// </summary>
        public string ORDER_ { get; set; }
        /// <summary>
        ///是否可用 1：是，0：否
        /// </summary>
        public bool? ISTRUE { get; set; }
        /// <summary>
        /// 专业分类 1：本科；2：专科；3：专升本；用于人才培养方案
        /// </summary>
        public string ZYFL_CODE { get; set; }
    }
    public class LessonInfoModel
    {
        public string LessonId { get; set; }
        public string LessonNo { get; set; }
        public string LessonName { get; set; }
        public string COURSE_TYPE_CODE { get; set; }
        public string COURSE_ATTR_CODE { get; set; }
        public string COURSE_NATURE_CODE { get; set; }
        public string F_SchoolId { get; set; }
        public bool? CheckMark { get; set; }
    }
    public class V_KCXX
    {
        public string ID { get; set; }
        /// <summary>
        /// 代码
        /// </summary>
        public string CODE_ { get; set; }
        /// <summary>
        /// 名称
        /// </summary>
        public string NAME_ { get; set; }
        /// <summary>
        /// 课程类型CODE  A类（纯理论课）/B类（（理论＋实践）课）/ C类（纯实践课）
        /// </summary>
        public string COURSE_TYPE_CODE { get; set; }
        /// <summary>
        /// 课程属性CODE 公共课、专业基础课、专业课。
        /// </summary>
        public string COURSE_ATTR_CODE { get; set; }
        /// <summary>
        /// 课程性质CODE 课程性质（单一选项）：必修课/专业选修课/公共选修课
        /// </summary>
        public string COURSE_NATURE_CODE { get; set; }
        /// <summary>
        /// 是否可用
        /// </summary>
        public bool? ISTRUE { get; set; }
    }
    public class TeachModel
    {
        public string EmpId { get; set; }
        public string ZZJG_ID { get; set; }
        public string F_DepartmentId { get; set; }
        public string EmpNo { get; set; }
        public string EmpName { get; set; }
        /// <summary>
        /// 编制类型 在编（1）、人事代理（2）、其他（9）（不可变更）
        /// </summary>
        public string BZLX_CODE { get; set; }
        public string IsInActiveStatus { get; set; }
        /// <summary>
        /// 教学类（10）、行政类（20）、教辅类（30）、工勤类（40）、外聘教师类（80）、科研类（50）、校办企业类（60）、附设机构类（70）、其他类（99）（不可变更）
        /// </summary>
        public string BZLB_CODE { get; set; }
        /// <summary>
        /// 教职工状态 在职（11，含其他原因在岗人员）、延聘（12）、返聘（04）、退休（01）、离职（07）、其他（99，表示不在校）等等，使用国标
        /// </summary>
        public string IdentityCardNo { get; set; }
        public string Birthday { get; set; }
        public string mobile { get; set; }
        /// <summary>
        /// 学历 博士研究生：01，硕士研究生：10，本科：20，专科：30，中专：40，技工：50，高中，60（不可变更
        /// </summary>
        public string HighestRecord { get; set; }
        /// <summary>
        /// 学位 名誉博士：1，博士：2，硕士：3，学士：4，双学士：5（不可变更）
        /// </summary>
        public string DegreeNo { get; set; }
        public string F_CompanyId { get; set; }
        public bool? CheckMark { get; set; }

    }
    public class V_JSXX
    {
        public string ID { get; set; }
        /// <summary>
        /// 组织机构ID
        /// </summary>
        public string ZZJG_ID { get; set; }
        public string DEPT_ID { get; set; }
        public string TEA_NO { get; set; }
        public string NAME_ { get; set; }
        /// <summary>
        /// 编制类型
        /// 在编（1）、人事代理（2）、其他（9）（不可变更）
        /// </summary>
        public string BZLX_CODE { get; set; }
        /// <summary>
        /// 教职工状态 
        /// 在职（11，含其他原因在岗人员）、延聘（12）、返聘（04）、退休（01）、离职（07）、其他（99，表示不在校）等等，使用国标
        /// </summary>
        public string TEA_STATUS_CODE { get; set; }
        /// <summary>
        /// 编制类别
        /// 教学类（10）、行政类（20）、教辅类（30）、工勤类（40）、外聘教师类（80）、科研类（50）、校办企业类（60）、附设机构类（70）、其他类（99）（不可变更）
        /// </summary>
        public string BZLB_CODE { get; set; }
        public string IDNO { get; set; }
        public string BIRTH_DATE { get; set; }
        public string PHONE { get; set; }
        /// <summary>
        /// 最高学历
        /// 博士研究生：01，硕士研究生：10，本科：20，专科：30，中专：40，技工：50，高中，60（不可变更）
        /// </summary>
        public string EDU_ID { get; set; }
        /// <summary>
        /// 最高学位
        /// 名誉博士：1，博士：2，硕士：3，学士：4，双学士：5（不可变更）
        /// </summary>
        public string DEGREE_ID { get; set; }
        public bool? IS_NORMAL { get; set; }
    }

    public class ClassModel
    {
        public string ClassId { get; set; }
        public string ClassNo { get; set; }
        public string ClassName { get; set; }
        public string MajorNo { get; set; }
        public string Educational { get; set; }
        /// <summary>
        /// 培养层次CODE 1：博士；2：硕士；3：本科；4：专科；9：其他（不可变更
        /// </summary>
        public string PYCC_CODE { get; set; }
        public string Grade { get; set; }
        public string GRADUATE_YEAR { get; set; }
        public string GRADUATE_SCHOOLYEAR { get; set; }
        public DateTime? GRADUATE_DATE { get; set; }
        public bool? CheckMark { get; set; }
        public string PINYIN { get; set; }
        public string NAME_SHORT { get; set; }
        public string PINYIN_SHORT { get; set; }

    }
    public class V_BJXX
    {
        public string ID { get; set; }
        public string NO_ { get; set; }
        public string NAME_ { get; set; }
        public string MAJOR_CODE { get; set; }
        public string LENGTH_SCHOOLING { get; set; }
        public string PYCC_CODE { get; set; }
        public string GRADE { get; set; }
        public string GRADUATE_YEAR { get; set; }
        public string GRADUATE_SCHOOLYEAR { get; set; }
        public string GRADUATE_DATE { get; set; }
        public bool? ISTRUE { get; set; }
        public string PINYIN { get; set; }
        public string NAME_SHORT { get; set; }
        public string PINYIN_SHORT { get; set; }
    }

    public class ClassRoomModel
    {
        public string ClassroomId { get; set; }
        public string ClassroomNo { get; set; }
        public string ClassroomName { get; set; }
        public string PID { get; set; }
        public string PATH_ { get; set; }
        public string ClassroomFloor { get; set; }
        public string LEVEL_TYPE { get; set; }
        public bool? CheckMark { get; set; }
        public string ORDER_ { get; set; }
        public string ClassroomTypeNo { get; set; }
        public string ContainStuNum { get; set; }
        public string ClassroomBuildingNo { get; set; }
        public string F_SchoolId { get; set; }
    }
    public class V_JS_ZZJG
    {
        public string ID { get; set; }
        public string CODE_ { get; set; }
        public string NAME_ { get; set; }
        public string PID { get; set; }
        public string PATH_ { get; set; }
        public string LEVEL_ { get; set; }
        public string LEVEL_TYPE { get; set; }
        public bool? ISTRUE { get; set; }
        public string ORDER_ { get; set; }
        /// <summary>
        /// 1：多媒体教室；2：语音室；3：实验室；4：计算机房；5：普通教室；6：专用教室；9：其他（不可变更）
        /// </summary>
        public string JSLX_CODE { get; set; }
        public string ZW_COUNT { get; set; }
        public string JXL_ID { get; set; }
        public string XQ_ID { get; set; }
    }
    public class V_XSXX
    {
        public string ID { get; set; }
        public string STU_NO { get; set; }
        public string NAME_ { get; set; }
        public string FORMER_NAME { get; set; }
        public string DEPT_ID { get; set; }
        public string MAJOR_CODE { get; set; }
        public string CLASS_ID { get; set; }
        public string PINYIN { get; set; }
        public string BIRTHDAY { get; set; }
        public string IDNO { get; set; }
        public string SEX_CODE { get; set; }
        public string NATION_CODE { get; set; }
        public string POLITICS_CODE { get; set; }
        public string LENGTH_SCHOOLING { get; set; }
        public string PYCC_CODE { get; set; }
        public string ENROLL_DATE { get; set; }
        public string ENROLL_GRADE { get; set; }
        public string STU_STATE_CODE { get; set; }
        public string STU_ROLL_CODE { get; set; }
        public string IS_NORMAL { get; set; }
        public string KSH { get; set; }
    }

    public class V_Dept
    {
        public string ID { get; set; }

        public string CODE_ { get; set; }

        public string NAME_ { get; set; }

        public string PID { get; set; }

        public string PATH_ { get; set; }

        public string LEVEL_ { get; set; }

        public string LEVEL_TYPE { get; set; }

        public int ISTRUE { get; set; }

        public string NAME_SHORT { get; set; }

        public string ADMIN_MANAGE_TEA_NO { get; set; }
    }
    
}